#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>

char salidaname[20][100];

void grafico(int conta, char argu[],char f[][100],int flagg,char salidanamee[][100]);
void ping(int nhijo, int hopp,int duermee,char fx[][100]);

int main(int argc,char *argv[])
{
   //***definicion de las variables***
    FILE *fp;
    pid_t hijo[10],hijo3,padrepid;
    int count=0;
    int hop,duerme;
    char nomb[20][200];
    char f1[10][100];
    int c;
    int sflg = 0;
    int lflg = 0;
    int errflg = 0;

    //***comprueba los flag pasados al programa****
    while ((c = getopt(argc, argv, "sl:")) != EOF)
      switch (c) {
	case 's':
		if (lflg)
		  errflg++;
		else
		  sflg++;
		break;
	case 'l':
		if (sflg)
		  errflg++;
		else
		  lflg++;
		break;
	case '?':
	errflg++;
	}
    if ((errflg)||(argc!=4))
     {
     fprintf(stderr,"  Use: rttgraph [-s|-l] <in-file> <out-file>\n");
     exit (2);
     }

    printf("---Graficando la tasa de paquetes perdidos y RTT---\n");
    //Abre el archivo indicado por la variable argv[argc-2]
    if ((fp = fopen(argv[argc-2], "r")) == NULL)
        {
        //Escribe en el standar error si se ha producido un error al abrir el archivo
        fprintf(stderr, "Error al abrir el fichero %s.\n",argv[argc-2]);
        exit(1);
        }
    //Scanea el archivo de direcciones pasado como argumento
    printf(" Scaneando el archivo : %s\n",argv[argc-2]);
    while(fscanf(fp,"%s\n", &f1[count])!=EOF)
        {
	printf(" La direccion obtenida es: %s\n",f1[count]);
	count++;
	}
    //verifaica si se han encontrado datos en el archivo
    if(count==0)
     {
     printf(" No se ha encontrado nada en el archivo \"%s\" ......saliendo...\n",argv[argc-2]);
     exit(0);
     }

    //system("rm -f .ping* .salida*");

    printf(" El numero de direcciones obtenidas es: %d\n",count);

    for(int i=0;i<count;i++)
	{
	//caso corto parametro -s
	if(sflg==1)
          {
        //SE CREARAN TANTOS HIJOS COMO DIRECCIONES OBTENIDAS DEL FICHERO PASADO COMO ARGUMENTO
	   if ( (hijo[i] = fork()) == 0)   	//hijos
	      {
	      hijo[i]=getpid();
	      //printf("hijo %d mi pid es: %d\n",i,hijo[i]);
	      hop=5; //saltos
	      duerme=1000000;//tiempo en micro segundos
	      printf("\n Haciendo %d ping's a %s  \n",hop,f1[i]);
	      printf("     Espere........ \n");
	      //llama al funcion que obtiene losndatos del comando ping
              ping(i, hop, duerme, f1);
	      }
	  }
	//caso largo parametro -l
	if(lflg==1)
           {
	   if ( (hijo[i] = fork()) == 0)   	//hijos
	      {
	      hop=1440; //saltos
	      duerme=60000000;//tiempo en micro segundos
	      //hop=5; //saltos
	      //duerme=4000000;//tiempo en micro segundos
	      printf("\n Haciendo %d ping's a %s \n",hop,f1[i]);
	      printf("     Espere........ \n");
	      //llama al funcion que obtiene losndatos del comando ping
              ping(i, hop, duerme, f1);
	      }
	   }
	}

    //espera a que finalicen los hijos
    for(int i=0;i<count;i++)
	{
	waitpid(hijo[i],NULL,0);
	}
    printf("\n **** Toma de datos finalizada ****\n\n");


    for(int ii=0;ii<count;ii++)
       sprintf(salidaname[ii],".salidaloss%d.txt",hijo[ii]);

    sprintf(nomb[1],"%s.rtt.ps",argv[argc-1]);
    sprintf(nomb[2],"%s.loss.ps",argv[argc-1]);
    printf(" Genrando archivos de salida: \n");
    printf("                            \"%s\" \n",nomb[1]);
    printf("                            \"%s\" \n\n",nomb[2]);
    //genera archivo graph.gnu para ser utilizado por el gnu.plot
    grafico(count, argv[argc-1], f1,sflg,salidaname);

    fclose(fp);

    padrepid=getpid();

    //genera el grafico de salida en formato *.ps
    sprintf(nomb[5],"gnuplot graph%d.gnu",padrepid);
    sprintf(nomb[6],"gnuplot graph2%d.gnu",padrepid);
    system(nomb[5]);
    system(nomb[6]);
    //elimina los archivos temporales generados
    //comentando a continuaion se pueden conservar estos
    for(int ii=0;ii<count;ii++)
       {
       sprintf(nomb[4],"rm -f .ping%d.txt .pingloss%d.txt .pingrtt%d.txt .salidaloss%d.txt",hijo[ii],hijo[ii],hijo[ii],hijo[ii]);
       system(nomb[4]);
       }

    sprintf(nomb[5],"rm -f graph%d.gnu graph2%d.gnu",padrepid,padrepid);
    system(nomb[5]);

    exit(0);
}

